import { NativeAnimationEvent, NativeClipboardEvent, NativeCompositionEvent, NativeDragEvent, NativeFocusEvent, NativeKeyboardEvent, NativeMouseEvent, NativePointerEvent, NativeTouchEvent, NativeTransitionEvent, NativeUIEvent, NativeWheelEvent } from '../../JSX';
import { LinkedEvent } from './linkEvent';
export interface SemiSyntheticEvent<T> extends Event {
    /**
     * A reference to the element on which the event listener is registered.
     */
    currentTarget: EventTarget & T;
}
export declare type ClipboardEvent<T> = SemiSyntheticEvent<T> & NativeClipboardEvent;
export declare type CompositionEvent<T> = SemiSyntheticEvent<T> & NativeCompositionEvent;
export declare type DragEvent<T> = MouseEvent<T> & NativeDragEvent;
export declare type FocusEvent<T> = SemiSyntheticEvent<T> & NativeFocusEvent;
export declare type FormEvent<T> = SemiSyntheticEvent<T>;
export interface InvalidEvent<T> extends SemiSyntheticEvent<T> {
    target: EventTarget & T;
}
export interface ChangeEvent<T> extends SemiSyntheticEvent<T> {
    target: EventTarget & T;
}
export declare type KeyboardEvent<T> = SemiSyntheticEvent<T> & NativeKeyboardEvent;
export declare type MouseEvent<T> = SemiSyntheticEvent<T> & NativeMouseEvent;
export declare type TouchEvent<T> = SemiSyntheticEvent<T> & NativeTouchEvent;
export declare type PointerEvent<T> = SemiSyntheticEvent<T> & NativePointerEvent;
export declare type UIEvent<T> = SemiSyntheticEvent<T> & NativeUIEvent;
export declare type WheelEvent<T> = MouseEvent<T> & NativeWheelEvent;
export declare type AnimationEvent<T> = SemiSyntheticEvent<T> & NativeAnimationEvent;
export declare type TransitionEvent<T> = SemiSyntheticEvent<T> & NativeTransitionEvent;
export declare type EventHandler<E extends SemiSyntheticEvent<any>> = {
    bivarianceHack(event: E): void;
}['bivarianceHack'] | LinkedEvent<any, E> | null;
export declare type InfernoEventHandler<T = Element> = EventHandler<SemiSyntheticEvent<T>>;
export declare type ClipboardEventHandler<T = Element> = EventHandler<ClipboardEvent<T>>;
export declare type CompositionEventHandler<T = Element> = EventHandler<CompositionEvent<T>>;
export declare type DragEventHandler<T = Element> = EventHandler<DragEvent<T>>;
export declare type FocusEventHandler<T = Element> = EventHandler<FocusEvent<T>>;
export declare type FormEventHandler<T = Element> = EventHandler<FormEvent<T>>;
export declare type ChangeEventHandler<T = Element> = EventHandler<ChangeEvent<T>>;
export declare type KeyboardEventHandler<T = Element> = EventHandler<KeyboardEvent<T>>;
export declare type MouseEventHandler<T = Element> = EventHandler<MouseEvent<T>>;
export declare type TouchEventHandler<T = Element> = EventHandler<TouchEvent<T>>;
export declare type PointerEventHandler<T = Element> = EventHandler<PointerEvent<T>>;
export declare type UIEventHandler<T = Element> = EventHandler<UIEvent<T>>;
export declare type WheelEventHandler<T = Element> = EventHandler<WheelEvent<T>>;
export declare type AnimationEventHandler<T = Element> = EventHandler<AnimationEvent<T>>;
export declare type TransitionEventHandler<T = Element> = EventHandler<TransitionEvent<T>>;
